<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>ServerCnxn.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server</a> &gt; <span class="el_source">ServerCnxn.java</span></div><h1>ServerCnxn.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server;

import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.net.InetSocketAddress;
import java.nio.ByteBuffer;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.concurrent.atomic.AtomicLong;

import org.apache.jute.Record;
import org.apache.zookeeper.WatchedEvent;
import org.apache.zookeeper.Watcher;
import org.apache.zookeeper.data.Id;
import org.apache.zookeeper.proto.ReplyHeader;
import org.apache.zookeeper.proto.RequestHeader;

/**
 * Interface to a Server connection - represents a connection from a client
 * to the server.
 */
<span class="fc" id="L44">public abstract class ServerCnxn implements Stats, Watcher {</span>
    // This is just an arbitrary object to represent requests issued by
    // (aka owned by) this class
<span class="fc" id="L47">    final public static Object me = new Object();</span>
    
<span class="fc" id="L49">    protected ArrayList&lt;Id&gt; authInfo = new ArrayList&lt;Id&gt;();</span>

    /**
     * If the client is of old version, we don't send r-o mode info to it.
     * The reason is that if we would, old C client doesn't read it, which
     * results in TCP RST packet, i.e. &quot;connection reset by peer&quot;.
     */
<span class="fc" id="L56">    boolean isOldClient = true;</span>

    abstract int getSessionTimeout();

    abstract void close();

    public abstract void sendResponse(ReplyHeader h, Record r, String tag)
        throws IOException;

    /* notify the client the session is closing and close/cleanup socket */
    abstract void sendCloseSession();

    public abstract void process(WatchedEvent event);

    abstract long getSessionId();

    abstract void setSessionId(long sessionId);

    /** auth info for the cnxn, returns an unmodifyable list */
    public List&lt;Id&gt; getAuthInfo() {
<span class="fc" id="L76">        return Collections.unmodifiableList(authInfo);</span>
    }

    public void addAuthInfo(Id id) {
<span class="fc bfc" id="L80" title="All 2 branches covered.">        if (authInfo.contains(id) == false) {</span>
<span class="fc" id="L81">            authInfo.add(id);</span>
        }
<span class="fc" id="L83">    }</span>

    public boolean removeAuthInfo(Id id) {
<span class="nc" id="L86">        return authInfo.remove(id);</span>
    }

    abstract void sendBuffer(ByteBuffer closeConn);

    abstract void enableRecv();

    abstract void disableRecv();

    abstract void setSessionTimeout(int sessionTimeout);

<span class="fc" id="L97">    protected ZooKeeperSaslServer zooKeeperSaslServer = null;</span>

    protected static class CloseRequestException extends IOException {
        private static final long serialVersionUID = -7854505709816442681L;

        public CloseRequestException(String msg) {
<span class="fc" id="L103">            super(msg);</span>
<span class="fc" id="L104">        }</span>
    }

    protected static class EndOfStreamException extends IOException {
        private static final long serialVersionUID = -8255690282104294178L;

        public EndOfStreamException(String msg) {
<span class="fc" id="L111">            super(msg);</span>
<span class="fc" id="L112">        }</span>

        public String toString() {
<span class="fc" id="L115">            return &quot;EndOfStreamException: &quot; + getMessage();</span>
        }
    }

    /*
     * See &lt;a href=&quot;{@docRoot}/../../../docs/zookeeperAdmin.html#sc_zkCommands&quot;&gt;
     * Zk Admin&lt;/a&gt;. this link is for all the commands.
     */
<span class="fc" id="L123">    protected final static int confCmd =</span>
<span class="fc" id="L124">        ByteBuffer.wrap(&quot;conf&quot;.getBytes()).getInt();</span>

    /*
     * See &lt;a href=&quot;{@docRoot}/../../../docs/zookeeperAdmin.html#sc_zkCommands&quot;&gt;
     * Zk Admin&lt;/a&gt;. this link is for all the commands.
     */
<span class="fc" id="L130">    protected final static int consCmd =</span>
<span class="fc" id="L131">        ByteBuffer.wrap(&quot;cons&quot;.getBytes()).getInt();</span>

    /*
     * See &lt;a href=&quot;{@docRoot}/../../../docs/zookeeperAdmin.html#sc_zkCommands&quot;&gt;
     * Zk Admin&lt;/a&gt;. this link is for all the commands.
     */
<span class="fc" id="L137">    protected final static int crstCmd =</span>
<span class="fc" id="L138">        ByteBuffer.wrap(&quot;crst&quot;.getBytes()).getInt();</span>

    /*
     * See &lt;a href=&quot;{@docRoot}/../../../docs/zookeeperAdmin.html#sc_zkCommands&quot;&gt;
     * Zk Admin&lt;/a&gt;. this link is for all the commands.
     */
<span class="fc" id="L144">    protected final static int dumpCmd =</span>
<span class="fc" id="L145">        ByteBuffer.wrap(&quot;dump&quot;.getBytes()).getInt();</span>

    /*
     * See &lt;a href=&quot;{@docRoot}/../../../docs/zookeeperAdmin.html#sc_zkCommands&quot;&gt;
     * Zk Admin&lt;/a&gt;. this link is for all the commands.
     */
<span class="fc" id="L151">    protected final static int enviCmd =</span>
<span class="fc" id="L152">        ByteBuffer.wrap(&quot;envi&quot;.getBytes()).getInt();</span>

    /*
     * See &lt;a href=&quot;{@docRoot}/../../../docs/zookeeperAdmin.html#sc_zkCommands&quot;&gt;
     * Zk Admin&lt;/a&gt;. this link is for all the commands.
     */
<span class="fc" id="L158">    protected final static int getTraceMaskCmd =</span>
<span class="fc" id="L159">        ByteBuffer.wrap(&quot;gtmk&quot;.getBytes()).getInt();</span>

    /*
     * See &lt;a href=&quot;{@docRoot}/../../../docs/zookeeperAdmin.html#sc_zkCommands&quot;&gt;
     * Zk Admin&lt;/a&gt;. this link is for all the commands.
     */
<span class="fc" id="L165">    protected final static int ruokCmd =</span>
<span class="fc" id="L166">        ByteBuffer.wrap(&quot;ruok&quot;.getBytes()).getInt();</span>
    /*
     * See &lt;a href=&quot;{@docRoot}/../../../docs/zookeeperAdmin.html#sc_zkCommands&quot;&gt;
     * Zk Admin&lt;/a&gt;. this link is for all the commands.
     */
<span class="fc" id="L171">    protected final static int setTraceMaskCmd =</span>
<span class="fc" id="L172">        ByteBuffer.wrap(&quot;stmk&quot;.getBytes()).getInt();</span>

    /*
     * See &lt;a href=&quot;{@docRoot}/../../../docs/zookeeperAdmin.html#sc_zkCommands&quot;&gt;
     * Zk Admin&lt;/a&gt;. this link is for all the commands.
     */
<span class="fc" id="L178">    protected final static int srvrCmd =</span>
<span class="fc" id="L179">        ByteBuffer.wrap(&quot;srvr&quot;.getBytes()).getInt();</span>

    /*
     * See &lt;a href=&quot;{@docRoot}/../../../docs/zookeeperAdmin.html#sc_zkCommands&quot;&gt;
     * Zk Admin&lt;/a&gt;. this link is for all the commands.
     */
<span class="fc" id="L185">    protected final static int srstCmd =</span>
<span class="fc" id="L186">        ByteBuffer.wrap(&quot;srst&quot;.getBytes()).getInt();</span>

    /*
     * See &lt;a href=&quot;{@docRoot}/../../../docs/zookeeperAdmin.html#sc_zkCommands&quot;&gt;
     * Zk Admin&lt;/a&gt;. this link is for all the commands.
     */
<span class="fc" id="L192">    protected final static int statCmd =</span>
<span class="fc" id="L193">        ByteBuffer.wrap(&quot;stat&quot;.getBytes()).getInt();</span>

    /*
     * See &lt;a href=&quot;{@docRoot}/../../../docs/zookeeperAdmin.html#sc_zkCommands&quot;&gt;
     * Zk Admin&lt;/a&gt;. this link is for all the commands.
     */
<span class="fc" id="L199">    protected final static int wchcCmd =</span>
<span class="fc" id="L200">        ByteBuffer.wrap(&quot;wchc&quot;.getBytes()).getInt();</span>

    /*
     * See &lt;a href=&quot;{@docRoot}/../../../docs/zookeeperAdmin.html#sc_zkCommands&quot;&gt;
     * Zk Admin&lt;/a&gt;. this link is for all the commands.
     */
<span class="fc" id="L206">    protected final static int wchpCmd =</span>
<span class="fc" id="L207">        ByteBuffer.wrap(&quot;wchp&quot;.getBytes()).getInt();</span>

    /*
     * See &lt;a href=&quot;{@docRoot}/../../../docs/zookeeperAdmin.html#sc_zkCommands&quot;&gt;
     * Zk Admin&lt;/a&gt;. this link is for all the commands.
     */
<span class="fc" id="L213">    protected final static int wchsCmd =</span>
<span class="fc" id="L214">        ByteBuffer.wrap(&quot;wchs&quot;.getBytes()).getInt();</span>

    /*
     * See &lt;a href=&quot;{@docRoot}/../../../docs/zookeeperAdmin.html#sc_zkCommands&quot;&gt;
     * Zk Admin&lt;/a&gt;. this link is for all the commands.
     */
<span class="fc" id="L220">    protected final static int mntrCmd = ByteBuffer.wrap(&quot;mntr&quot;.getBytes())</span>
<span class="fc" id="L221">            .getInt();</span>

    /*
     * See &lt;a href=&quot;{@docRoot}/../../../docs/zookeeperAdmin.html#sc_zkCommands&quot;&gt;
     * Zk Admin&lt;/a&gt;. this link is for all the commands.
     */
<span class="fc" id="L227">    protected final static int isroCmd = ByteBuffer.wrap(&quot;isro&quot;.getBytes())</span>
<span class="fc" id="L228">            .getInt();</span>

<span class="fc" id="L230">    protected final static HashMap&lt;Integer, String&gt; cmd2String =</span>
        new HashMap&lt;Integer, String&gt;();

    // specify all of the commands that are available
    static {
<span class="fc" id="L235">        cmd2String.put(confCmd, &quot;conf&quot;);</span>
<span class="fc" id="L236">        cmd2String.put(consCmd, &quot;cons&quot;);</span>
<span class="fc" id="L237">        cmd2String.put(crstCmd, &quot;crst&quot;);</span>
<span class="fc" id="L238">        cmd2String.put(dumpCmd, &quot;dump&quot;);</span>
<span class="fc" id="L239">        cmd2String.put(enviCmd, &quot;envi&quot;);</span>
<span class="fc" id="L240">        cmd2String.put(getTraceMaskCmd, &quot;gtmk&quot;);</span>
<span class="fc" id="L241">        cmd2String.put(ruokCmd, &quot;ruok&quot;);</span>
<span class="fc" id="L242">        cmd2String.put(setTraceMaskCmd, &quot;stmk&quot;);</span>
<span class="fc" id="L243">        cmd2String.put(srstCmd, &quot;srst&quot;);</span>
<span class="fc" id="L244">        cmd2String.put(srvrCmd, &quot;srvr&quot;);</span>
<span class="fc" id="L245">        cmd2String.put(statCmd, &quot;stat&quot;);</span>
<span class="fc" id="L246">        cmd2String.put(wchcCmd, &quot;wchc&quot;);</span>
<span class="fc" id="L247">        cmd2String.put(wchpCmd, &quot;wchp&quot;);</span>
<span class="fc" id="L248">        cmd2String.put(wchsCmd, &quot;wchs&quot;);</span>
<span class="fc" id="L249">        cmd2String.put(mntrCmd, &quot;mntr&quot;);</span>
<span class="fc" id="L250">        cmd2String.put(isroCmd, &quot;isro&quot;);</span>
<span class="fc" id="L251">    }</span>

    protected void packetReceived() {
<span class="fc" id="L254">        incrPacketsReceived();</span>
<span class="fc" id="L255">        ServerStats serverStats = serverStats();</span>
<span class="fc bfc" id="L256" title="All 2 branches covered.">        if (serverStats != null) {</span>
<span class="fc" id="L257">            serverStats().incrementPacketsReceived();</span>
        }
<span class="fc" id="L259">    }</span>

    protected void packetSent() {
<span class="fc" id="L262">        incrPacketsSent();</span>
<span class="fc" id="L263">        ServerStats serverStats = serverStats();</span>
<span class="fc bfc" id="L264" title="All 2 branches covered.">        if (serverStats != null) {</span>
<span class="fc" id="L265">            serverStats().incrementPacketsSent();</span>
        }
<span class="fc" id="L267">    }</span>

    protected abstract ServerStats serverStats();
    
<span class="fc" id="L271">    protected final Date established = new Date();</span>

<span class="fc" id="L273">    protected final AtomicLong packetsReceived = new AtomicLong();</span>
<span class="fc" id="L274">    protected final AtomicLong packetsSent = new AtomicLong();</span>

    protected long minLatency;
    protected long maxLatency;
    protected String lastOp;
    protected long lastCxid;
    protected long lastZxid;
    protected long lastResponseTime;
    protected long lastLatency;

    protected long count;
    protected long totalLatency;

    public synchronized void resetStats() {
<span class="fc" id="L288">        packetsReceived.set(0);</span>
<span class="fc" id="L289">        packetsSent.set(0);</span>
<span class="fc" id="L290">        minLatency = Long.MAX_VALUE;</span>
<span class="fc" id="L291">        maxLatency = 0;</span>
<span class="fc" id="L292">        lastOp = &quot;NA&quot;;</span>
<span class="fc" id="L293">        lastCxid = -1;</span>
<span class="fc" id="L294">        lastZxid = -1;</span>
<span class="fc" id="L295">        lastResponseTime = 0;</span>
<span class="fc" id="L296">        lastLatency = 0;</span>

<span class="fc" id="L298">        count = 0;</span>
<span class="fc" id="L299">        totalLatency = 0;</span>
<span class="fc" id="L300">    }</span>

    protected long incrPacketsReceived() {
<span class="fc" id="L303">        return packetsReceived.incrementAndGet();</span>
    }
    
    protected void incrOutstandingRequests(RequestHeader h) {
<span class="fc" id="L307">    }</span>

    protected long incrPacketsSent() {
<span class="fc" id="L310">        return packetsSent.incrementAndGet();</span>
    }

    protected synchronized void updateStatsForResponse(long cxid, long zxid,
            String op, long start, long end)
    {
        // don't overwrite with &quot;special&quot; xids - we're interested
        // in the clients last real operation
<span class="fc bfc" id="L318" title="All 2 branches covered.">        if (cxid &gt;= 0) {</span>
<span class="fc" id="L319">            lastCxid = cxid;</span>
        }
<span class="fc" id="L321">        lastZxid = zxid;</span>
<span class="fc" id="L322">        lastOp = op;</span>
<span class="fc" id="L323">        lastResponseTime = end;</span>
<span class="fc" id="L324">        long elapsed = end - start;</span>
<span class="fc" id="L325">        lastLatency = elapsed;</span>
<span class="pc bpc" id="L326" title="1 of 2 branches missed.">        if (elapsed &lt; minLatency) {</span>
<span class="nc" id="L327">            minLatency = elapsed;</span>
        }
<span class="fc bfc" id="L329" title="All 2 branches covered.">        if (elapsed &gt; maxLatency) {</span>
<span class="fc" id="L330">            maxLatency = elapsed;</span>
        }
<span class="fc" id="L332">        count++;</span>
<span class="fc" id="L333">        totalLatency += elapsed;</span>
<span class="fc" id="L334">    }</span>

    public Date getEstablished() {
<span class="fc" id="L337">        return (Date)established.clone();</span>
    }

    public abstract long getOutstandingRequests();

    public long getPacketsReceived() {
<span class="fc" id="L343">        return packetsReceived.longValue();</span>
    }

    public long getPacketsSent() {
<span class="fc" id="L347">        return packetsSent.longValue();</span>
    }

    public synchronized long getMinLatency() {
<span class="pc bpc" id="L351" title="1 of 2 branches missed.">        return minLatency == Long.MAX_VALUE ? 0 : minLatency;</span>
    }

    public synchronized long getAvgLatency() {
<span class="pc bpc" id="L355" title="1 of 2 branches missed.">        return count == 0 ? 0 : totalLatency / count;</span>
    }

    public synchronized long getMaxLatency() {
<span class="fc" id="L359">        return maxLatency;</span>
    }

    public synchronized String getLastOperation() {
<span class="fc" id="L363">        return lastOp;</span>
    }

    public synchronized long getLastCxid() {
<span class="fc" id="L367">        return lastCxid;</span>
    }

    public synchronized long getLastZxid() {
<span class="fc" id="L371">        return lastZxid;</span>
    }

    public synchronized long getLastResponseTime() {
<span class="fc" id="L375">        return lastResponseTime;</span>
    }

    public synchronized long getLastLatency() {
<span class="fc" id="L379">        return lastLatency;</span>
    }

    /**
     * Prints detailed stats information for the connection.
     *
     * @see dumpConnectionInfo(PrintWriter, boolean) for brief stats
     */
    @Override
    public String toString() {
<span class="nc" id="L389">        StringWriter sw = new StringWriter();</span>
<span class="nc" id="L390">        PrintWriter pwriter = new PrintWriter(sw);</span>
<span class="nc" id="L391">        dumpConnectionInfo(pwriter, false);</span>
<span class="nc" id="L392">        pwriter.flush();</span>
<span class="nc" id="L393">        pwriter.close();</span>
<span class="nc" id="L394">        return sw.toString();</span>
    }

    public abstract InetSocketAddress getRemoteSocketAddress();
    public abstract int getInterestOps();
    
    /**
     * Print information about the connection.
     * @param brief iff true prints brief details, otw full detail
     * @return information about this connection
     */
    protected synchronized void
    dumpConnectionInfo(PrintWriter pwriter, boolean brief) {
<span class="fc" id="L407">        pwriter.print(&quot; &quot;);</span>
<span class="fc" id="L408">        pwriter.print(getRemoteSocketAddress());</span>
<span class="fc" id="L409">        pwriter.print(&quot;[&quot;);</span>
<span class="fc" id="L410">        int interestOps = getInterestOps();</span>
<span class="fc bfc" id="L411" title="All 2 branches covered.">        pwriter.print(interestOps == 0 ? &quot;0&quot; : Integer.toHexString(interestOps));</span>
<span class="fc" id="L412">        pwriter.print(&quot;](queued=&quot;);</span>
<span class="fc" id="L413">        pwriter.print(getOutstandingRequests());</span>
<span class="fc" id="L414">        pwriter.print(&quot;,recved=&quot;);</span>
<span class="fc" id="L415">        pwriter.print(getPacketsReceived());</span>
<span class="fc" id="L416">        pwriter.print(&quot;,sent=&quot;);</span>
<span class="fc" id="L417">        pwriter.print(getPacketsSent());</span>

<span class="fc bfc" id="L419" title="All 2 branches covered.">        if (!brief) {</span>
<span class="fc" id="L420">            long sessionId = getSessionId();</span>
<span class="fc bfc" id="L421" title="All 2 branches covered.">            if (sessionId != 0) {</span>
<span class="fc" id="L422">                pwriter.print(&quot;,sid=0x&quot;);</span>
<span class="fc" id="L423">                pwriter.print(Long.toHexString(sessionId));</span>
<span class="fc" id="L424">                pwriter.print(&quot;,lop=&quot;);</span>
<span class="fc" id="L425">                pwriter.print(getLastOperation());</span>
<span class="fc" id="L426">                pwriter.print(&quot;,est=&quot;);</span>
<span class="fc" id="L427">                pwriter.print(getEstablished().getTime());</span>
<span class="fc" id="L428">                pwriter.print(&quot;,to=&quot;);</span>
<span class="fc" id="L429">                pwriter.print(getSessionTimeout());</span>
<span class="fc" id="L430">                long lastCxid = getLastCxid();</span>
<span class="pc bpc" id="L431" title="1 of 2 branches missed.">                if (lastCxid &gt;= 0) {</span>
<span class="fc" id="L432">                    pwriter.print(&quot;,lcxid=0x&quot;);</span>
<span class="fc" id="L433">                    pwriter.print(Long.toHexString(lastCxid));</span>
                }
<span class="fc" id="L435">                pwriter.print(&quot;,lzxid=0x&quot;);</span>
<span class="fc" id="L436">                pwriter.print(Long.toHexString(getLastZxid()));</span>
<span class="fc" id="L437">                pwriter.print(&quot;,lresp=&quot;);</span>
<span class="fc" id="L438">                pwriter.print(getLastResponseTime());</span>
<span class="fc" id="L439">                pwriter.print(&quot;,llat=&quot;);</span>
<span class="fc" id="L440">                pwriter.print(getLastLatency());</span>
<span class="fc" id="L441">                pwriter.print(&quot;,minlat=&quot;);</span>
<span class="fc" id="L442">                pwriter.print(getMinLatency());</span>
<span class="fc" id="L443">                pwriter.print(&quot;,avglat=&quot;);</span>
<span class="fc" id="L444">                pwriter.print(getAvgLatency());</span>
<span class="fc" id="L445">                pwriter.print(&quot;,maxlat=&quot;);</span>
<span class="fc" id="L446">                pwriter.print(getMaxLatency());</span>
            }
        }
<span class="fc" id="L449">        pwriter.print(&quot;)&quot;);</span>
<span class="fc" id="L450">    }</span>

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>